using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;

namespace SelectionsApp
{
	/// <summary>
	/// Summary description for TestingForm.
	/// </summary>
	public class TestingForm : System.Windows.Forms.Form
	{
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button btnELF1;
		private System.Windows.Forms.Button btnELF2;
		private System.Windows.Forms.Button btnShowELF;
		ExecutionListingForm elf;
		private System.Windows.Forms.Button btnColorScheme;
		ArrayList fList = null;

		public TestingForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			elf = new ExecutionListingForm();
			elf.MatchedOnly = false;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnELF1 = new System.Windows.Forms.Button();
			this.btnELF2 = new System.Windows.Forms.Button();
			this.btnShowELF = new System.Windows.Forms.Button();
			this.btnColorScheme = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnELF1
			// 
			this.btnELF1.Location = new System.Drawing.Point(40, 32);
			this.btnELF1.Name = "btnELF1";
			this.btnELF1.TabIndex = 0;
			this.btnELF1.Text = "ELF AddExecutions";
			this.btnELF1.Click += new System.EventHandler(this.btnELF_Click);
			// 
			// btnELF2
			// 
			this.btnELF2.Location = new System.Drawing.Point(40, 80);
			this.btnELF2.Name = "btnELF2";
			this.btnELF2.TabIndex = 2;
			this.btnELF2.Text = "ELF GetExec";
			this.btnELF2.Click += new System.EventHandler(this.btnELF2_Click);
			// 
			// btnShowELF
			// 
			this.btnShowELF.Location = new System.Drawing.Point(144, 80);
			this.btnShowELF.Name = "btnShowELF";
			this.btnShowELF.TabIndex = 7;
			this.btnShowELF.Text = "Show ELF";
			this.btnShowELF.Click += new System.EventHandler(this.btnShowELF_Click);
			// 
			// btnColorScheme
			// 
			this.btnColorScheme.Location = new System.Drawing.Point(144, 24);
			this.btnColorScheme.Name = "btnColorScheme";
			this.btnColorScheme.Size = new System.Drawing.Size(72, 32);
			this.btnColorScheme.TabIndex = 12;
			this.btnColorScheme.Text = "ELF SET RANDOM COLORS";
			this.btnColorScheme.Click += new System.EventHandler(this.btnColorScheme_Click);
			// 
			// TestingForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 118);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnColorScheme,
																		  this.btnShowELF,
																		  this.btnELF2,
																		  this.btnELF1});
			this.Name = "TestingForm";
			this.Text = "TestingForm";
			this.Resize += new System.EventHandler(this.TestingForm_Resize);
			this.Load += new System.EventHandler(this.TestingForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnELF_Click(object sender, System.EventArgs e)
		{
//			elf.AddExecution(createExec(9));
			elf.AddExecutions(createExecs((new Random()).Next(150)));
			
		}




		protected IList createExecs(int x)
		{
			ArrayList eList = new ArrayList();
			for(int y =1; y <= x; y++)
			{
				eList.Add(createExec((int)(y*(new Random(4*x/9)).Next(40))));
				eList.Add(createExec(y));
			}
			return eList;
		}

		protected Hashtable createExec(int x)
		{
			Hashtable h = new Hashtable();
			h[Nodes.Action] = x%3==0? "BUY":"SELL";
			h[Nodes.QUANTITY] = "3000"+x;
			h[Nodes.REMQUANTITY] = h[Nodes.QUANTITY];
			h[Nodes.SYMBOL] = "AICL-"+(int)(x* (new Random(4*x/9)).Next());
			h[Nodes.PRICE] = 99.999*x ;
			h[Nodes.Market] = "HKG-HK";
			h[Nodes.ReportedOn] = "";//new string[] { "AAFDGF0492", "13929320" };
			h[Nodes.REFNUM] = "0001";
			if(System.DateTime.Now.Ticks%x == 0)
                h[Nodes.ShowAsMatched] = "false";
			else
				h[Nodes.ShowAsMatched] = "true";
			h[Nodes.TIMESTAMP] = System.DateTime.Now.ToLongTimeString();
			h[Nodes.Broker] = "M.F.K.";
			h[Nodes.ORDERID] = x%3==0?"A00001"+x:"A00002"+x;
			h[Nodes.SEQNUM] = "0202101"+x;
			h[Nodes.PRODUCT] = "New Product";
			return h;
		}

		private void btnELF2_Click(object sender, System.EventArgs e)
		{
			ArrayList elist = (ArrayList)elf.Executions;
			ArrayList mlist = (ArrayList)elf.MatchedExecutions;
			ArrayList uList = (ArrayList)elf.UnmatchedExecutions;
			ArrayList sList = (ArrayList)elf.SelectedExecutions;

			MessageBox.Show(elist.Count+"||"+mlist.Count+"||"+uList.Count+"||"+sList.Count);
		}

		private void btnShowELF_Click(object sender, System.EventArgs e)
		{
			elf.Show();		
		}


		
		private void btn_Click(object sender, System.EventArgs e)
		{
			elf.GroupExecution = (!elf.GroupExecution);
		}

		private void btnELF3_Click(object sender, System.EventArgs e)
		{
			elf.MatchedOnly = false;
			elf.MatchedExecutionsOnTop = (!elf.MatchedExecutionsOnTop);
			elf.AddExecution(createExec(9));
			elf.UnreportedOnly = (!elf.UnreportedOnly);
		}

		private void TestingForm_Load(object sender, System.EventArgs e)
		{
//			MessageBox.Show(elf.MatchedExecutionsOnTop+"");
//			elf.MatchedExecutionsOnTop = false;
		}

		private void TestingForm_Resize(object sender, System.EventArgs e)
		{
//			MessageBox.Show(elf.MatchedExecutionsOnTop+"");
		}


		private void button2_Click(object sender, System.EventArgs e)
		{
			elf.DeleteExecution(createExec(9));
	//		elf.ClearExecutions();
		}


		private void btnColorScheme_Click(object sender, System.EventArgs e)
		{
			elf.ColorScheme = GetRandomColorScheme();

		}

		protected Hashtable GetRandomColorScheme()
		{
			Random r = new Random(System.DateTime.Now.Millisecond);
			Hashtable ht = new Hashtable();
			Hashtable buy = new Hashtable();
			Hashtable sell = new Hashtable();
			Hashtable sellshort = new Hashtable();
			Hashtable selection = new Hashtable();
			buy[Nodes.ForeColor] = Color.FromArgb(r.Next(255),r.Next(255),r.Next(255));
			sell[Nodes.ForeColor] = Color.FromArgb(r.Next(255),r.Next(255),r.Next(255));
			sellshort[Nodes.ForeColor] = Color.FromArgb(r.Next(255),r.Next(255),r.Next(255));
			selection[Nodes.ForeColor] = Color.FromArgb(r.Next(255),r.Next(255),r.Next(255));
			selection[Nodes.BackColor] = Color.FromArgb(111,111,111);
			selection[Nodes.Font] = this.Font;
            
			ht[Nodes.Buy] = buy;
			ht[Nodes.Sell] = sell;
			ht[Nodes.SellShort] = sellshort;
			ht[Nodes.Selection] = selection;

			return ht;
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			elf.Error = "OOPS";
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			new Thread(new ThreadStart(this.Update1)).Start();
		}

		protected void Update1()
		{
			IList executions = elf.Executions;
			foreach(Hashtable ht in executions)
			{
				Hashtable exec = ht.Clone() as Hashtable;
				exec[Nodes.QUANTITY] = 2200;
				elf.AddExecution(exec);
			}
		}

	}
}